public inbox for network@lists.ipfire.org
 help / color / mirror / Atom feed
* [PATCH v2] config hook: prevent two hooks with the same settings
@ 2017-07-27 12:07 Jonatan Schlag
  0 siblings, 0 replies; only message in thread
From: Jonatan Schlag @ 2017-07-27 12:07 UTC (permalink / raw)
  To: network

[-- Attachment #1: Type: text/plain, Size: 3044 bytes --]

A ipv4-static config with the same IPv4 address twice is senseless.
A new function zone_config_check_same_setting is introduced.
The function provides an easy way to check if a config
of the given hook has the same value for a given key.
We can now check inside hook_new if an ipv4-static or ipv6-static config
with the same value exist and break with an error.

Fixes: #11418

Signed-off-by: Jonatan Schlag <jonatan.schlag(a)ipfire.org>
---
 src/functions/functions.zone  | 33 +++++++++++++++++++++++++++++++++
 src/hooks/configs/ipv4-static |  5 +++++
 src/hooks/configs/ipv6-static |  5 +++++
 3 files changed, 43 insertions(+)

diff --git a/src/functions/functions.zone b/src/functions/functions.zone
index a3ca029..1eb492f 100644
--- a/src/functions/functions.zone
+++ b/src/functions/functions.zone
@@ -1150,6 +1150,39 @@ zone_config_get_new_id() {
 	done
 }
 
+zone_config_check_same_setting() {
+	# This functions checks if a config hook
+	# with the same setting is already configured for this zone.
+	# Returns True when yes and False when no.
+
+	assert [ $# -eq 4 ]
+
+	local zone=${1}
+	local hook=${2}
+	local key=${3}
+	local value=${4}
+
+	# The key should be local for this function
+	local ${key}
+	local config
+
+	for config in $(zone_configs_list ${zone}); do
+		# Check if the config is from the given hook, when not continue
+		if  [[ $(zone_config_get_hook "${zone}" "${config}") != ${hook} ]]; then
+			continue
+		fi
+		# Get the value of the key for a given function
+		zone_config_settings_read "${zone}" "${config}" \
+                --ignore-superfluous-settings "${key}"
+		# Check if the value of the config and the passed value are eqal
+		if [[ "${value}" == "${!key}" ]]; then
+			return ${EXIT_TRUE}
+		fi
+	done
+
+	return ${EXIT_FALSE}
+}
+
 zone_config_get_hook() {
 	assert [ $# -eq 2 ]
 
diff --git a/src/hooks/configs/ipv4-static b/src/hooks/configs/ipv4-static
index 36629e0..ef74991 100644
--- a/src/hooks/configs/ipv4-static
+++ b/src/hooks/configs/ipv4-static
@@ -99,6 +99,11 @@ hook_parse_cmdline() {
 		exit ${EXIT_CONF_ERROR}
 	fi
 
+	if zone_config_check_same_setting "${zone}" "ipv4-static" "ADDRESS" "${ADDRESS}"; then
+		error "An ipv4-static config with the same IPv4 address is already configured"
+		exit ${EXIT_CONF_ERROR}
+	fi
+
 	if ! isset GATEWAY && zone_is_nonlocal "${zone}"; then
 		warning "You did not configure a gateway for a non-local zone"
 	fi
diff --git a/src/hooks/configs/ipv6-static b/src/hooks/configs/ipv6-static
index 4c1d7df..c41401c 100644
--- a/src/hooks/configs/ipv6-static
+++ b/src/hooks/configs/ipv6-static
@@ -49,6 +49,11 @@ hook_parse_cmdline() {
 		shift
 	done
 
+	if zone_config_check_same_setting "${zone}" "ipv6-static" "ADDRESS" "${ADDRESS}"; then
+		error "An ipv6-static config with the same IPv6 address is already configured"
+		exit ${EXIT_CONF_ERROR}
+	fi
+
 	# Store IPv6 address in small format.
 	ADDRESS=$(ipv6_format "${ADDRESS}")
 
-- 
2.6.3


^ permalink raw reply	[flat|nested] only message in thread

only message in thread, other threads:[~2017-07-27 12:07 UTC | newest]

Thread overview: (only message) (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2017-07-27 12:07 [PATCH v2] config hook: prevent two hooks with the same settings Jonatan Schlag

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox